; File Name   :	d:\hobby3\tiny\es\es40\float_fuer_basic.jtc
; Format      :	Binary file
; Base Address:	0000h Range: CF80h - E000h Loaded length: 1080h

;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255

		cpu z8601
		assume RP:0C0h		; keine Optimierung durch AS!

; Segment type:	Internal processor memory & SFR
; segment INTMEM
; p0 equ	0				; Port 0
; p1 equ	1				; Port 1
; p2 equ	2				; Port 2
; p3 equ	3				; Port 3
byte_4 equ 4
byte_5 equ 5
byte_6 equ 6
byte_7 equ 7
word_A equ 0Ah
word_C equ 0Ch
byte_E equ 0Eh
byte_F equ 0Fh
unk_14 equ 14h
byte_15	equ 15h
byte_16	equ 16h
byte_2C	equ 2Ch
byte_2D	equ 2Dh
byte_40	equ 40h
byte_41	equ 41h
byte_42	equ 42h
byte_43	equ 43h
byte_44	equ 44h
byte_4A	equ 4Ah
byte_4B	equ 4Bh
byte_4C	equ 4Ch
byte_4D	equ 4Dh
byte_4E	equ 4Eh
byte_4F	equ 4Fh
byte_58	equ 58h
byte_60	equ 60h
byte_61	equ 61h
byte_62	equ 62h
byte_70	equ 70h				; FP0
byte_71	equ 71h
byte_72	equ 72h
byte_73	equ 73h
byte_74	equ 74h
byte_75	equ 75h
byte_76	equ 76h				; FP1
byte_77	equ 77h
byte_79	equ 79h
byte_7A	equ 7Ah
byte_7C	equ 7Ch
byte_7D	equ 7Dh
byte_7F	equ 7Fh

imr equ 0FBh				; Interrupt mask register
flags equ 0FCh				; Program control flags
rp equ	0FDh				; Register pointer
gpr equ 0FEh				; General purpose register
spl equ 0FFh				; Stack	pointer
; end of "INTMEM"


		org 0D000h

; Gleitkomma-Akku: FP0: %70%75, FP1: %76%7B
; Gleitkomma-Puffer: %F750-%F76F
fpbuf	equ	0F750h
fpmem	equ	08000h			; Anfangsadresse des Variablenspeichers

;------------------------------------------------------------------------------
; FP0=FP0-FP1
;------------------------------------------------------------------------------

FSUB:		xor	byte_76, #80h

;------------------------------------------------------------------------------
; FP0=FP0+FP1
;------------------------------------------------------------------------------


FADD:		push	rp		; Register pointer
		srp	#70h

fadd1:		ld	R12, #7Fh
		ld	R13, #7Fh
		and	R12, R0
		and	R13, R6
		cp	R12, R13
		jr	NC, fadd3
		ld	R12, #6
fadd2:		ld	R13, 6Fh(R12)
		ld	R14, 75h(R12)
		ld	75h(R12), R13
		ld	6Fh(R12), R14
		djnz	R12, fadd2
		jr	fadd1

fadd3:		sub	R12, R13
		jr	Z, fadd6
		cp	R12, #5
		jr	C, fadd5
fadd4:		rcf
		pop	rp		; Register pointer
		ret
		db 0FFh
		db 0FFh

fadd5:		ld	R11, R10
		ld	R10, R9
		ld	R9, R8
		ld	R8, R7
		ld	R7, #0
		djnz	R12, fadd5
fadd6:		ld	R12, R0
		xor	R12, R6
		jr	MI, fadd8
		add	R5, R11
		da	R5
		adc	R4, R10
		da	R4
		adc	R3, R9
		da	R3
		adc	R2, R8
		da	R2
		adc	R1, R7
		da	R1
		jr	NC, fadd4
		nop
		nop
		ld	R5, R4
		ld	R4, R3
		ld	R3, R2
		ld	R2, R1
		ld	R1, #1
		inc	R0
fadd7:		ld	R12, #7Fh
		and	R12, R0
		cp	R12, #0Fh
		ccf
		jp	NC, loc_D31F
		cp	R12, #72h
		ccf
		pop	rp		; Register pointer
		ret

fadd8:		sub	R5, R11
		da	R5
		sbc	R4, R10
		da	R4
		sbc	R3, R9
		da	R3
		sbc	R2, R8
		da	R2
		sbc	R1, R7
		da	R1
		jr	NC, fadd10
		xor	R0, #80h
		rcf
		ld	R12, #75h
		ld	R13, #5
fadd9:		ld	R14, #0
		sbc	R14, @R12
		da	R14
		ld	@R12, R14
		dec	R12
		djnz	R13, fadd9
		nop
		nop
fadd10:		ld	R12, #71h
		ld	R13, #5
fadd11:		or	@byte_7C, #0
		jr	NZ, fadd7
		dec	R0
		nop
		ld	R1, R2
		ld	R2, R3
		ld	R3, R4
		ld	R4, R5
		ld	R5, #0
		djnz	R13, fadd11
		ld	R0, #0
		rcf
		pop	rp		; Register pointer
		ret

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_D0D0:	ld	R8, #2Eh
		db  0Dh			; nachfolgend als NOP
loc_D0D3:	ld	R8, #30h
loc_D0D5:	lde	@RR6, R8
		incw	RR6
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_D0DA:	ld	R8, #0F0h
		and	R8, @R10
		swap	R8
loc_D0E0:	or	R8, #30h
		jr	loc_D0D5


;
sub_D0E5:	ld	R8, #0Fh
		and	R8, @R10
		jr	loc_D0E0

		nop
		nop
		nop

;------------------------------------------------------------------------------
; wandelt Zahl aus FP0 in ASCII-String ab (076h/77).als letztes Zeichen steht ein Byte 000h
;------------------------------------------------------------------------------


FASC:		push	rp		; Register pointer
		srp	#70h
		or	R0, R0
		jr	PL, fasc1
		ld	R8, #'-'
		lde	@RR6, R8
		incw	RR6

fasc1:		jr	NZ, fasc3
		call	loc_D0D3

fasc2:		ld	R8, #0
		lde	@RR6, R8
		pop	rp		; Register pointer
		ret

fasc3:		and	R0, #7Fh
		ld	R9, #75h
		ld	R8, #4

fasc4:		or	@byte_79, #0
		jr	NZ, fasc5
		dec	R9
		djnz	R8, fasc4

fasc5:		cp	R0, #3Fh
		jr	C, fasc13
		jr	NZ, fasc8
		call	loc_D0D3
		call	sub_D0D0
		ld	R10, #71h

fasc6:		call	sub_D0DA
		cp	R10, R9
		jr	NZ, fasc7
		tm	@byte_7A, #0Fh
		jr	Z, fasc2
		nop
		nop
		nop

fasc7:		call	sub_D0E5
		inc	R10
		cp	R9, R10
		jr	NC, fasc6
		jr	fasc2
		db 0FFh

fasc8:		cp	R0, #'E'
		jr	NC, fasc13
		ld	R10, #71h
		add	R0, #31h
		tm	R1, #0F0h
		jr	Z, fasc9
		call	sub_D0DA
fasc9:		call	sub_D0E5
fasc10:		cp	R10, R0
		jr	C, fasc11
		cp	R10, R9
		jr	NC, fasc2
		cp	R0, R10
		jr	NZ, fasc11
		call	sub_D0D0
fasc11:		nop
		nop
		inc	R10
		call	sub_D0DA
		nop
		cp	R10, R9
		jr	C, fasc12
		cp	R0, R10
		jr	NC, fasc12
		tm	@byte_7A, #0Fh
		jr	Z, fasc2
fasc12:		call	sub_D0E5
		jr	fasc10

fasc13:		rl	R0
		ld	R10, #71h
		tm	R1, #0F0h
		jr	Z, fasc15
		nop
		inc	R0
		call	sub_D0DA
		cp	R10, R9
		jr	NZ, fasc14
		tm	R1, #0Fh
		jr	Z, fasc18
fasc14:		call	sub_D0D0
		call	sub_D0E5
		jr	fasc16

fasc15:		call	sub_D0E5
		cp	R10, R9
		jr	Z, fasc18
		call	sub_D0D0
fasc16:		inc	R10
		nop
		call	sub_D0DA
		cp	R10, R9
		jr	C, fasc17
		tm	@byte_7A, #0Fh
		jr	Z, fasc18
fasc17:		call	sub_D0E5
		cp	R10, R9
		jr	C, fasc16
		nop
fasc18:		ld	R8, #'E'
		lde	@RR6, R8
		incw	RR6
		ld	R9, #7Fh
		and	R9, R0
		cp	R0, #-80h
		jr	NC, fasc19
		ld	R8, #'-'
		lde	@RR6, R8
		incw	RR6
		ld	R9, #80h
		sub	R9, R0
fasc19:		ld	R8, #30h
fasc20:		cp	R9, #0Ah
		jr	C, fasc21
		inc	R8
		sub	R9, #0Ah
		jr	fasc20

fasc21:		nop
		lde	@RR6, R8
		incw	RR6
		ld	R8, #30h
		add	R8, R9
		lde	@RR6, R8
		incw	RR6
		ld	R8, #0
		lde	@RR6, R8
		pop	rp		; Register pointer
		ret

		nop

;------------------------------------------------------------------------------
; druckt die Zahl aus FP0 aus
;------------------------------------------------------------------------------

PASC:		push	rp		; Register pointer
		srp	#70h
		ld	R6, #hi(fpbuf)	; Gleitkomma-Puffer:
		ld	R7, #lo(fpbuf)
		call	FASC
		ld	R6, #hi(fpbuf)	; Gleitkomma-Puffer:
		ld	R7, #lo(fpbuf)
		push	byte_15
pasc1:		ld	R8, #15h
		ldei	@R8, @RR6
		or	byte_15, byte_15
		jr	Z, pasc2
		call	818h
		jr	pasc1

pasc2:		pop	byte_15
		pop	rp		; Register pointer
		ret

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_D220:	sub	R11, #30h
		jr	C, locret_D229
		cp	R11, #0Ah
		ccf
locret_D229:	ret


;
sub_D22A:	cp	R14, #7Bh
		jr	NC, locret_D232
		ld	@R14, R11
		inc	R14
locret_D232:	ret

		nop

;------------------------------------------------------------------------------
; wandelt den ASCII-String ab (07Ch/7D) in eine Zahl in FP0, 
; (07Ch/7D) zeigt dann auf 1. nicht umwandelbares Zeichen
;------------------------------------------------------------------------------

ASCF:		push	rp		; Register pointer
		srp	#70h
		ld	R15, #0Bh
		ld	R11, #0

ascf1:		ld	6Fh(R15), R11
		djnz	R15, ascf1
		ld	R15, #7Fh
		ld	R14, #71h
		lde	R11, @RR12
		cp	R11, #'-'
		jr	NZ, ascf3
		ld	R0, #80h

ascf2:		incw	RR12
		lde	R11, @RR12

ascf3:		cp	R11, #'0'
		jr	Z, ascf2
		nop
		nop

ascf4:		lde	R11, @RR12
		incw	RR12
		cp	R11, #'E'
		jr	Z, ascf11
		cp	R11, #'.'
		jr	Z, ascf5
		call	sub_D220
		jr	C, ascf7
		call	sub_D22A
		inc	R15
		jr	ascf4

ascf5:		cp	R14, #71h
		jr	Z, ascf9
ascf6:		lde	R11, @RR12
		incw	RR12
		cp	R11, #'E'
		jr	Z, ascf11
		call	sub_D220
		jr	C, ascf16
		call	sub_D22A
		jr	ascf6

ascf7:		jr	ascf16

ascf8:		dec	R15
ascf9:		lde	R11, @RR12
		incw	RR12
		cp	R11, #'0'
		jr	Z, ascf8
ascf10:		cp	R11, #'E'
		jr	Z, ascf11
		call	sub_D220
		jr	C, ascf16
		call	sub_D22A
		lde	R11, @RR12
		incw	RR12
		jr	ascf10
		db 0FFh

ascf11:		lde	R11, @RR12
		incw	RR12
		ld	R14, #0
		cp	R11, #'+'
		jr	Z, ascf11
		cp	R11, #'-'
		jr	NZ, ascf12
		ld	R14, #80h
		lde	R11, @RR12
		incw	RR12
ascf12:		call	sub_D220
		jr	C, ascf16
		ld	byte_60, R11
		ld	byte_62, R11
		lde	R11, @RR12
		incw	RR12
		call	sub_D220
		jr	C, ascf14
		ld	byte_62, R11
		clr	byte_61
		ld	R11, #0Ah
ascf13:		add	byte_61, byte_60
		djnz	R11, ascf13
		add	byte_62, byte_61
		incw	RR12
ascf14:		nop
		or	R14, R14
		jr	MI, ascf15
		add	byte_7F, byte_62
		jr	ascf16

ascf15:		sub	byte_7F, byte_62
ascf16:		decw	RR12
		push	R12
		push	R13
		ld	R11, #71h
		ld	R12, #71h
		ld	R13, #5
ascf17:		ld	R14, @R11
		inc	R11
		swap	R14
		or	R14, @R11
		inc	R11
		ld	@R12, R14
		inc	R12
		djnz	R13, ascf17
		pop	R13
		pop	R12
		jp	loc_D7D3

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

loc_D310:	ld	R6, #6
		ld	R7, #0
loc_D314:	ld	1Fh(R6), R7
		djnz	R6, loc_D314
		pop	rp		; Register pointer
		ret

		db 0FFh
		db 0FFh
		db 0FFh

;

loc_D31F:	ld	R6, #6
		ld	R7, #0
loc_D323:	ld	6Fh(R6), R7
		djnz	R6, loc_D323
loc_D328:	pop	rp		; Register pointer
		ret

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_D330:	push	rp		; Register pointer
		srp	#20h
		ld	R12, #40h
		ld	R13, #10h
loc_D338:	push	@byte_2C
		clr	@byte_2C
		inc	R12
		djnz	R13, loc_D338
		ld	R12, #5
loc_D341:	ld	R13, 26h(R12)
		ld	49h(R12), R13
		djnz	R12, loc_D341
		ld	R12, #4
loc_D34B:	rcf
		rrc	byte_4A
		rrc	byte_4B
		rrc	byte_4C
		rrc	byte_4D
		rrc	byte_4E
		rrc	byte_4F
		djnz	R12, loc_D34B
		nop
		nop
		srp	#70h
		ld	R0, #'%'
		ld	R1, #49h
loc_D362:	ld	R2, #0Fh
		and	R2, @R0
		jr	Z, loc_D388
loc_D368:	ld	R3, #'+'
		ld	R4, R1
		ld	R5, #5
		rcf
loc_D36F:	ld	R6, @R4
		adc	R6, @R3
		da	R6
		ld	@R4, R6
		dec	R4
		dec	R3
		djnz	R5, loc_D36F
		jr	NC, loc_D384
		adc	@byte_74, #0
		da	@byte_74
loc_D384:	djnz	R2, loc_D368
		nop
		nop
loc_D388:	ld	R2, #0F0h
		and	R2, @R0
		jr	Z, loc_D3AF
		swap	R2
loc_D390:	ld	R3, #4Fh
		ld	R4, R1
		ld	R5, #6
		rcf
loc_D397:	ld	R6, @R4
		adc	R6, @R3
		da	R6
		ld	@R4, R6
		dec	R4
		dec	R3
		djnz	R5, loc_D397
		jr	NC, loc_D3AC
		adc	@byte_74, #0
		da	@byte_74
loc_D3AC:	djnz	R2, loc_D390
		nop
loc_D3AF:	dec	R1
		dec	R0
		cp	R0, #21h
		jr	NC, loc_D362
		srp	#20h
		ld	R12, #7Fh
		ld	R13, #7Fh
		and	R12, R0
		and	R13, R6
		sub	R12, #40h
		sub	R13, #40h
		add	R12, R13
		jr	MI, loc_D3D5
		cp	R12, #32h
		jr	C, loc_D3D3
		ld	R12, #34h
loc_D3D3:	jr	loc_D3DC
loc_D3D5:	cp	R12, #0CDh
		jr	NC, loc_D3DC
		ld	R12, #0CAh
loc_D3DC:	add	R12, #40h
		xor	R0, R6
		and	R0, #80h
		ld	R13, #40h
		inc	R12
		or	byte_40, byte_40
		jr	NZ, loc_D3F0
		dec	R12
		ld	R13, #41h
loc_D3F0:	nop
		nop
		ld	R1, @R13
		inc	R13
		ld	R2, @R13
		inc	R13
		ld	R3, @R13
		inc	R13
		ld	R4, @R13
		inc	R13
		ld	R5, @R13
		or	R0, R12
		ld	R13, #4Fh
		ld	R14, #10h
loc_D406:	pop	@byte_2D
		dec	R13
		djnz	R14, loc_D406
		or	R1, R1
		jr	Z, loc_D41C
		cp	R12, #0Fh
		jr	C, loc_D41C
		cp	R12, #72h
		ccf
		pop	rp		; Register pointer
		ret

loc_D41C:	rcf
		jp	loc_D310

		db 0FFh
		db 0FFh

loc_D422:	scf
		ret

;------------------------------------------------------------------------------
; FP0=FP0/FP1, ist FP1 null, wird das C-Flag gesetzt
;------------------------------------------------------------------------------

FDIV:		or	byte_76, byte_76
		jr	Z, loc_D422
		push	rp		; Register pointer
		srp	#70h
		ld	R12, #40h
		ld	R13, #10h
fdiv1:		push	@byte_7C
		inc	R12
		djnz	R13, fdiv1
		ld	R14, #7Fh
		ld	R15, #7Fh
		and	R14, R0
		and	R15, R6
		sub	R14, #40h
		sub	R15, #40h
		sub	R14, R15
		xor	R0, R6
		and	R0, #80h
		ld	R15, #0
		ld	R6, #0
		ld	R12, #0
		tm	R1, #0F0h
		jr	Z, fdiv3
		inc	R15
		ld	R13, #4
fdiv2:		rcf
		rrc	R1
		rrc	R2
		rrc	R3
		rrc	R4
		rrc	R5
		rrc	R6
		djnz	R13, fdiv2
		nop
fdiv3:		tm	R7, #0F0h
		jr	Z, fdiv5
		dec	R15
		ld	R13, #4
fdiv4:		rcf
		rrc	R7
		rrc	R8
		rrc	R9
		rrc	R10
		rrc	R11
		rrc	R12
		djnz	R13, fdiv4
fdiv5:		srp	#40h
		ld	R0, #0
		ld	R1, #0
		ld	R2, #0
		ld	R3, #0
		ld	R4, #0
		ld	R9, #0Ah
		jr	fdiv8

fdiv6:		ld	R5, #4
fdiv7:		rcf
		rlc	byte_76
		rlc	byte_75
		rlc	byte_74
		rlc	byte_73
		rlc	byte_72
		rlc	byte_71
		rcf
		rlc	R4
		rlc	R3
		rlc	R2
		rlc	R1
		rlc	R0
		djnz	R5, fdiv7
fdiv8:		ld	R5, #76h
		ld	R6, #7Ch
		ld	R7, #6
		rcf
fdiv9:		ld	R8, @R5
		sbc	R8, @R6
		da	R8
		dec	R5
		dec	R6
		djnz	R7, fdiv9
		jr	C, fdiv11
		inc	R4
		ld	R5, #76h
		ld	R6, #7Ch
		ld	R7, #6
		rcf
		nop
fdiv10:		ld	R8, @R5
		sbc	R8, @R6
		da	R8
		ld	@R5, R8
		dec	R5
		dec	R6
		djnz	R7, fdiv10
		jr	fdiv8

fdiv11:		djnz	R9, fdiv6
		srp	#70h
		ld	R1, byte_40
		ld	R2, byte_41
		ld	R3, byte_42
		ld	R4, byte_43
		ld	R5, byte_44
		tm	R1, #0F0h
		jr	NZ, fdiv13
		ld	R13, #4
fdiv12:		rcf
		rlc	R5
		rlc	R4
		rlc	R3
		rlc	R2
		rlc	R1
		djnz	R13, fdiv12
		dec	R15
fdiv13:		nop
		nop
		sra	R15
		jr	C, fdiv15
		ld	R13, #4
fdiv14:		rcf
		rrc	R1
		rrc	R2
		rrc	R3
		rrc	R4
		rrc	R5
		djnz	R13, fdiv14
fdiv15:		add	R14, R15
		ld	R12, #40h
		add	R12, R14
		or	R0, R12
		ld	R12, #4Fh
		ld	R13, #10h
fdiv16:		pop	@byte_7C
		dec	R12
		djnz	R13, fdiv16
		or	R1, R1
		jp	Z, loc_D41C
		or	R14, R14
		jr	PL, fdiv18
		cp	R14, #0CFh
		jp	C, loc_D41C
fdiv17:		pop	rp		; Register pointer
		ret

fdiv18:		cp	R14, #31h
		ccf
		jr	fdiv17

		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; FP0=FP0*FP1
;------------------------------------------------------------------------------

FMUL:		push	rp		; Register pointer
		srp	#70h
		ld	R12, #20h
		ld	R13, #10h
fmul1:		push	@byte_7C
		inc	R12
		djnz	R13, fmul1
		ld	R12, #0Ch
fmul2:		ld	R13, 6Fh(R12)
		ld	1Fh(R12), R13
		djnz	R12, fmul2
		call	sub_D330
		ld	R12, #6
fmul3:		ld	R13, 1Fh(R12)
		ld	6Fh(R12), R13
		djnz	R12, fmul3
		ld	R12, #2Fh
		ld	R13, #10h
fmul4:		pop	@byte_7C
		dec	R12
		djnz	R13, fmul4
		pop	rp		; Register pointer
		ret

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; wandelt vorzeichenbehaftete Integerzahl aus 076h/77 nach FP0
;------------------------------------------------------------------------------

HEXF:		push	rp		; Register pointer
		srp	#70h
		ld	R15, #0
		or	R6, R6
		jr	PL, hexf1
		ld	R15, #80h
		com	R6
		com	R7
		incw	RR6
hexf1:		ld	R0, #42h
		ld	R3, #0
		ld	R4, #0
		ld	R5, #0
		ld	R8, #5
		ld	R10, #hi(tab4)
		ld	R11, #lo(tab4)
hexf2:		ld	R12, #4
hexf3:		rcf
		rlc	R3
		rlc	R2
		rlc	R1
		djnz	R12, hexf3
		ld	R9, #7Ch
		ldei	@R9, @RR10
		ldei	@R9, @RR10
hexf4:		cp	R7, R13
		ld	R9, R6
		sbc	R9, R12
		jr	C, hexf5
		inc	R3
		sub	R7, R13
		sbc	R6, R12
		jr	hexf4

hexf5:		djnz	R8, hexf2
		or	R0, R15
		ld	R8, #3
hexf6:		or	R1, R1
		jr	NZ, hexf7
		dec	R0
		ld	R1, R2
		ld	R2, R3
		ld	R3, R4
		djnz	R8, hexf6
		ld	R0, #0
hexf7:		pop	rp		; Register pointer
		ret

		db 0FFh

tab4:		dw 10000
		dw 1000
		dw 100
		dw 10
		dw 1

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; wandelt die Zahl aus FP0 in vorzeichenbehaftete Integerzahl nach 076h/77
;------------------------------------------------------------------------------

FHEX:		push	rp		; Register pointer
		srp	#70h
		ld	R6, #0
		ld	R7, #0
		ld	R15, #0
		or	R0, R0
		jr	PL, fhex1
		ld	R15, #80h
fhex1:		jr	Z, fhex6
		and	R0, #7Fh
		cp	R0, #43h
		jr	NC, fhex6
		cp	R0, #40h
		jr	C, fhex6
fhex2:		ld	R8, #2
fhex3:		rcf
		rlc	R7
		rlc	R6
		ld	R10, R6
		ld	R11, R7
		ld	R9, #4
fhex4:		add	R7, R11
		adc	R6, R10
		djnz	R9, fhex4
		ld	R12, #0
		ld	R9, #4
fhex5:		rlc	R3
		rlc	R2
		rlc	R1
		rlc	R12
		djnz	R9, fhex5
		add	R7, R12
		adc	R6, #0
		djnz	R8, fhex3
		dec	R0
		cp	R0, #40h
		jr	NC, fhex2
		or	R15, R15
		jr	PL, fhex6
		com	R6
		com	R7
		incw	RR6
fhex6:		pop	rp		; Register pointer
		ret

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_D640:	push	R6
		push	R5
		push	R4
		ld	R2, #0
		ld	R3, #0
loc_D64A:	lde	R6, @RR0
		sub	R6, #30h
		jr	C, loc_D673
		cp	R6, #0Ah
		jr	NC, loc_D673
		incw	RR0
		ld	R4, R2
		ld	R5, R3
		add	R3, R3
		adc	R2, R2
		add	R3, R3
		adc	R2, R2
		add	R3, R5
		adc	R2, R4
		add	R3, R3
		adc	R2, R2
		add	R3, R6
		adc	R2, #0
		jr	loc_D64A
loc_D673:	pop	R4
		pop	R5
		pop	R6
		ret

		db 0FFh
		db 0FFh

;
sub_D67C:	ld	R4, #0
		ld	R5, #0
		ld	R7, #0
loc_D682:	lde	R6, @RR0
		cp	R6, #'+'
		jr	NZ, loc_D68F
		ld	R7, #0
loc_D68B:	incw	RR0
		jr	loc_D682

loc_D68F:	cp	R6, #'-'
		jr	NZ, loc_D698
		ld	R7, #80h
		jr	loc_D68B

loc_D698:	cp	R6, #'0'
		jr	C, loc_D6CA
		cp	R6, #'9'+1
		jr	NC, loc_D6A9
		call	sub_D640
		ld	R6, #12h
		jr	loc_D6B5

loc_D6A9:	cp	R6, #'Z'+1
		jr	NC, loc_D6CA
		add	R6, R6
		sub	R6, #62h
		incw	RR0
loc_D6B5:	inc	R6
		or	R7, R7
		jr	PL, loc_D6C2
		sub	R5, @R6
		dec	R6
		sbc	R4, @R6
		jr	loc_D682

loc_D6C2:	add	R5, @R6
		dec	R6
		adc	R4, @R6
		jr	loc_D682

loc_D6CA:	add	R5, R5
		adc	R4, R4
		ld	R2, R4
		ld	R3, R5
		add	R5, R5
		adc	R4, R4
		add	R5, R3
		adc	R4, R2
		add	R5, #lo(fpmem)
		adc	R4, #hi(fpmem)
		ret

		db 0FFh
		db 0FFh
		db 0FFh


loc_D6E4:	or	byte_E,	#0C0h
loc_D6E7:	jp	runf

loc_D6EA:	or	byte_E,	#30h
		jr	loc_D6E7

		db 0FFh
		db 0FFh
		db 0FFh

loc_D6F2:	srp	#70h
		ld	R6, R0
		ld	R7, R1
		ld	R8, R2
		ld	R9, R3
		ld	R10, R4
		ld	R11, R5
		srp	#10h
		pop	byte_75
		pop	byte_74
		pop	byte_73
		pop	byte_72
		pop	byte_71
		pop	byte_70
		cp	R12, #'-'
		jr	NZ, loc_D71A
		call	FSUB
		jr	C, loc_D6E4
		jr	loc_D757

loc_D71A:	cp	R12, #'+'
		jr	NZ, loc_D726
		call	FADD
		jr	C, loc_D6E4
		jr	loc_D757

loc_D726:	cp	R12, #'*'
		jr	NZ, loc_D732
		call	FMUL
		jr	C, loc_D6E4
		jr	loc_D757

loc_D732:	cp	R12, #'/'
		jr	NZ, loc_D6E4
		call	FDIV
		jr	C, loc_D6E4
		jr	loc_D757

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;
sub_D742:	nop
		nop
		nop
		nop
		ld	R13, #0


;
sub_D748:	clr	byte_70
		clr	byte_71
		clr	byte_72
		clr	byte_73
		clr	byte_74
		clr	byte_75
		ld	R12, #'+'
		db  0Dh			; nachfolgender Befehl als NOP

loc_D757:	ld	R12, #0

loc_D759:	lde	R6, @RR0
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		cp	R6, #')'
		jr	NZ, loc_D775
		or	R13, R13
		jp	Z, loc_D6EA
		dec	R13
		incw	RR0
		ret

loc_D775:	cp	R6, #'*'
		jr	Z, loc_D789
		cp	R6, #'+'
		jr	Z, loc_D789
		cp	R6, #'-'
		jr	Z, loc_D789
		cp	R6, #'/'
		jr	NZ, loc_D790

loc_D789:	ld	R12, R6
		incw	RR0
		jr	loc_D759
		db 0FFh

loc_D790:	push	byte_70
		push	byte_71
		push	byte_72
		push	byte_73
		push	byte_74
		push	byte_75
		cp	R6, #'A'
		jr	C, loc_D7BA
		cp	R6, #'Z'+1
		jr	NC, loc_D7BA
		add	R6, R6
		sub	R6, #62h
		ld	byte_76, @byte_16
		inc	R6
		ld	byte_77, @byte_16
		call	HEXF
		incw	RR0
		jp	loc_D6F2

loc_D7BA:	nop
		cp	R6, #'0'
		jr	C, loc_D800
		cp	R6, #'9'+1
		jr	NC, loc_D800
		ld	byte_7C, R0
		ld	byte_7D, R1
		call	ASCF
		ld	R0, byte_7C
		ld	R1, byte_7D
		jp	loc_D6F2

loc_D7D3:	nop
		rcf
		rrc	R15
		jr	C, loc_D7E8
		ld	R11, #4

loc_D7DB:	rcf
		rrc	R1
		rrc	R2
		rrc	R3
		rrc	R4
		rrc	R5
		djnz	R11, loc_D7DB

loc_D7E8:	cp	R15, #72h
		jr	NC, loc_D7F9
		cp	R15, #0Fh
		jr	C, loc_D7F9
		or	R0, R15
		or	R1, R1
		jp	NZ, loc_D328

loc_D7F9:	jp	loc_D31F
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

loc_D800:	cp	R6, #'['
		jr	NZ, loc_D826
		incw	RR0
		call	sub_D67C
		lde	R6, @RR0
		cp	R6, #']'
		jp	NZ, loc_D6EA
		incw	RR0
		ld	R6, #70h
		ldei	@R6, @RR4
		ldei	@R6, @RR4
		ldei	@R6, @RR4
		ldei	@R6, @RR4
		ldei	@R6, @RR4
		ldei	@R6, @RR4
		jp	loc_D6F2
		db 0FFh

loc_D826:	cp	R6, #28h
		jr	NZ, loc_D838
		push	R12
		inc	R13
		incw	RR0
		call	sub_D748
		pop	R12
		jp	loc_D6F2

loc_D838:	ld	R2, #16h
		ldei	@R2, @RR0
		ldei	@R2, @RR0
		ldei	@R2, @RR0
		ld	R10, #hi(proc_tab)	; Proc-Liste
		ld	R11, #lo(proc_tab)
		ld	R9, #10h
		nop

loc_D847:	ld	R2, #16h
		ld	R5, #5
		ld	R3, #3

loc_D84D:	lde	R4, @RR10
		incw	RR10
		dec	R5
		cp	R4, @R2
		jr	NZ, loc_D85C
		inc	R2
		djnz	R3, loc_D84D
		jr	loc_D865

loc_D85C:	add	R11, R5
		adc	R10, #0
		djnz	R9, loc_D847
		jr	loc_D88A

loc_D865:	lde	R4, @RR10
		incw	RR10
		lde	R5, @RR10
		push	R4
		push	R5
		lde	R6, @RR0
		cp	R6, #'('
		jp	NZ, loc_D6EA
		incw	RR0
		push	R12
		inc	R13
		call	sub_D748
		pop	R12
		pop	R5
		pop	R4
		call	@unk_14
		jp	loc_D6F2

loc_D88A:	decw	RR0
		decw	RR0
		decw	RR0
		ld	R2, #6
loc_D892:	pop	R3
		djnz	R2, loc_D892
		or	R13, R13
		jp	NZ, loc_D6EA
		ret

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		pop	R2
		pop	R3
		pop	R2
		pop	R3
		jp	loc_D925+1	;  ??? Codereste

;------------------------------------------------------------------------------
; bernahme aus U883-MPBASIC, leicht angepasst
;------------------------------------------------------------------------------

; nchste Zeile abarbeiten
run2:		tm	byte_F,	#0Ah
		jr	NZ, run4
		tcm	byte_F,	#84h
		jr	Z, run4
run3:		ldc	R6, @RR0
		inc	R6
		djnz	R6, run5
run4:		jp	@word_A

run5:		cp	byte_6,	R0
		jr	NZ, run6
		cp	byte_7,	R1
		jr	Z, run8
run6:		ld	R6, byte_4
		or	R6, byte_5
		jr	Z, run8
		push	R1
		push	R0
		ld	R0, byte_4
		ld	R1, byte_5
		call	545h
		jr	Z, run7
		call	6C9h
		pop	R6
		pop	R7
		decw	RR6
		push	R7
		push	R6
		incw	RR0
		call	692h
;;vp		jr	loc_D925+1	; ?Fehler !das muss jr run14 sein!
		jr	run14		; korrektur

; Zeile abarbeiten
run7:		pop	R0
		pop	R1
run8:		incw	RR0
		incw	RR0
run9:		ldc	R3, @RR0
		incw	RR0
		cp	R3, #'>'
		jr	Z, run10
		and	byte_F,	#0FEh
run10:		ld	R6, #hi(tab_kdo)
		ld	R7, #lo(tab_kdo)
		clr	R2
run11:		ldc	R8, @RR6
		cp	R8, R3
		jr	Z, run12
		incw	RR6
		inc	R2
		cp	R2, #20h
		jr	C, run11
		jr	runf0

run12:		add	R2, R2
		ld	R6, #hi(tab_kdo2)
		ld	R7, #lo(tab_kdo2)
		add	R7, R2
		adc	R6, #0
		ld	R2, #0Ch
loc_D925:	ldci	@R2, @RR6
		ldci	@R2, @RR6
run13:		call	@word_C
;
run14:		ld	R7, #0Dh
		call	391h
		jp	Z, run2
		cp	R6, #';'
		jr	Z, run9
		jr	run13

runf0:		jp	runf
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; Tabelle der BASIC-Kommandos
tab_kdo:	db  'L'
		db  'O'
		db  'G'
		db  'F'
		db  '>'
		db  'R'
		db  'S'
		db  'W'
		db  'M'
		db  'C'
		db  'T'
		db  'E'
		db  '!'
		db  '/'
		db  'P'
		db  'H'
		db  'I'
		; Erweiterung f. FLOAT
		db  '?'		
		db  'l'
		db  'i'
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0

tab_kdo2:	dw 59Ch
		dw 5B4h
		dw 604h
		dw 649h
		dw 657h
		dw 661h
		dw 67Bh
		dw 69Fh
		dw 583h
		dw 6B9h
		dw 6C1h
		dw 6C5h
		dw 5AEh
		dw 6C9h
		dw 6DDh
		dw 6CEh
		dw 715h
		; Erweiterung f. FLOAT
		dw PRINT		; ?
		dw LET			; l
		dw INPUT		; i
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;

tab3:		dw 8012h
tab5:		dw 0F700h

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_D9A4:	lde	R6, @RR0
		cp	R6, #'A'
		jr	C, locret_D9B2
		cp	R6, #'Z'+1
		jr	C, loc_D9C5
		jr	Z, loc_D9B3
locret_D9B2:	ret

loc_D9B3:	incw	RR0
		call	sub_D67C
loc_D9B8:	incw	RR0
		ld	R2, #hi(tab3)
		ld	R3, #lo(tab3)
		lde	@RR2, R4
		incw	RR2
		lde	@RR2, R5
		ret

loc_D9C5:	add	R6, R6
		ld	R4, #0
		ld	R5, #9Eh
		add	R5, R6
		jr	loc_D9B8

		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_D9D0:	ld	R2, #hi(tab3)
		ld	R3, #lo(tab3)
		lde	R4, @RR2
		incw	RR2
		lde	R5, @RR2
		or	R4, R4
		jr	Z, loc_D9ED
		ld	R6, #70h
		ldei	@RR4, @R6
		ldei	@RR4, @R6
		ldei	@RR4, @R6
		ldei	@RR4, @R6
		ldei	@RR4, @R6
		ldei	@RR4, @R6
		ret

loc_D9ED:	call	FHEX
		;ld	@byte_76, byte_15	; von ida falsch reassembliert	
		ld	@byte_15, byte_76	
		inc	R5
		;ld	@byte_77, byte_15	; von ida falsch reassembliert	
		ld	@byte_15, byte_77
		ret

;------------------------------------------------------------------------------
; Wertzuweisung Ausdruck an GK-Variable "let" analog "LET"
;------------------------------------------------------------------------------

LET:		call	sub_D9A4
		incw	RR0
		call	sub_D742
		call	sub_D9D0
		ret

;------------------------------------------------------------------------------
; Eingabe GK-Wert "i" analog "INPUT"
;------------------------------------------------------------------------------

INPUT:		call	sub_D9A4
		ld	byte_58, #0FFh
		call	815h
		ld	byte_58, #0FFh
		ld	byte_7C, #0F7h
		ld	byte_7D, #0
		call	ASCF
		call	sub_D9D0
		ret

		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; Proc-Liste
;------------------------------------------------------------------------------

proc_tab:	db "abs"
		dw ABS
		db "sgn"
		dw SGN
		db "int"
		dw INT

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; Absolutwert von expr
;------------------------------------------------------------------------------

ABS:		and	byte_70, #7Fh
		ret

;------------------------------------------------------------------------------
; Vorzeichen von expr, null, wenn expr null, -1 bzw. 1,
; wenn expr negativ bzw. positiv ist.
;------------------------------------------------------------------------------

SGN:		or	byte_70, byte_70
		jr	Z, sgn1
		and	byte_70, #80h
		or	byte_70, #40h
		ld	byte_71, #1
		clr	byte_72
		clr	byte_73
		clr	byte_74
		clr	byte_75
sgn1:		ret
		db 0FFh

;------------------------------------------------------------------------------
; Ganzzahl (Weglassen Nachkommastellen)
;------------------------------------------------------------------------------

INT:		ld	byte_76, byte_70
		and	byte_70, #7Fh
		cp	byte_70, #40h
		jr	NC, int1
		clr	byte_76
		ld	byte_70, #3Fh
int1:		cp	byte_70, #44h
		jr	C, int3
int2:		ld	byte_70, byte_76
		ret

int3:		add	byte_70, #32h
int4:		clr	@byte_70
		inc	byte_70
		cp	byte_70, #76h
		jr	C, int4
		jr	int2
		db 0FFh

;------------------------------------------------------------------------------
; Ausdrucken Text/GK-Zahl (Ausdruck)
;------------------------------------------------------------------------------

print0:		pop	R5
PRINT:		ld	R5, #0Dh
print1:		push	R5
		lde	R6, @RR0
		cp	R6, #';'
		jr	NZ, print4
print2:		pop	R5
		or	R5, R5
		jr	Z, print3
		call	818h
print3:		ret

print4:		cp	R6, #0Dh
		jr	Z, print2
		cp	R6, #','
		jr	NZ, print5
		pop	R5
		ld	R5, #0
		incw	RR0
		jr	print1
print5:		cp	R6, #'"'
		jr	NZ, print7
		incw	RR0
print6:		lde	R5, @RR0
		incw	RR0
		cp	R5, #'"'
		jr	Z, print0
		call	818h
		jr	print6

print7:		call	sub_D742
		call	PASC
		jr	print0

;------------------------------------------------------------------------------
; die Erweiterung aktivieren:
;------------------------------------------------------------------------------

START:		ld	R2, #4
start1:		pop	R3
		djnz	R2, start1
		ld	R2, #hi(tab5)
		ld	R3, #lo(tab5)
		ld	R4, #0FEh
		ldei	@RR2, @R4
		ldei	@RR2, @R4
		jp	run14
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

runf:		ld	R5, imr		; Interrupt mask register
		di
		ld	R2, #hi(tab5)
		ld	R3, #lo(tab5)
		ld	R4, #0FEh
		ldei	@R4, @RR2
		ldei	@R4, @RR2
		ld	imr, R5		; Interrupt mask register
		jp	@word_A


		end START
